<script setup lang="ts">
import type { VoteInformation, DKGStatus } from '@/scripts/types'
import { PropType, defineEmits, reactive } from 'vue'
import API from '@/scripts/api'
import { useDataStore } from '@/store/data'
import { useAppStore } from '@/store/app'

const data = useDataStore()
const app = useAppStore()

const emit = defineEmits(['clone'])
const props = defineProps({
  vote: {
    type: Object as PropType<VoteInformation>,
    required: true
  }
})

function refreshVotes() {
  data.refreshVotes()
}

function openVote() {
  API.openVote(props.vote.id).then(() => {
    refreshVotes()
    app.notification('info', `Vote n°${props.vote.id} ouvert !`)
  }).catch(err => {
    console.error(err)
  })
}

function deleteVote() {
  API.deleteVote(props.vote.id).then(() => {
    refreshVotes()
    app.notification('info', `Vote n°${props.vote.id} supprimé !`)
  }).catch(err => {
    console.error(err)
  })
}

function cancelVote() {
  API.updateVoteStatus(props.vote.id, 'canceled').then(() => {
    refreshVotes()
    app.notification('info', `Vote n°${props.vote.id} annulé !`)
  }).catch(err => {
    console.error(err)
  })
}

function archiveVote() {
  API.updateVoteStatus(props.vote.id, 'archived').then(() => {
    refreshVotes()
    app.notification('info', `Vote n°${props.vote.id} archivé !`)
  }).catch(err => {
    console.error(err)
  })
}

const dkgManagerModal = reactive({
  displayed: false,
  iKnowWhatIDo: false,
  dkgStatus: null as DKGStatus | null
})

function openDKGManager() {
  dkgManagerModal.displayed = true
  dkgManagerModal.iKnowWhatIDo = false
  dkgManagerModal.dkgStatus = null
  API.debugDKG(props.vote.id).then(status => {
    dkgManagerModal.dkgStatus = status
  })
}

function resetDKG(type: 'public' | 'private') {
  if (!dkgManagerModal.iKnowWhatIDo) return
  API.resetDKG(props.vote.id, type)
}
</script>

<template>
  <div>
    <v-card variant="plain" v-if="vote.status === 'prepared' && vote.vote_pubkey == null" class="m-2">
      <v-card-text>
        <p class="text-xl mb-1">En préparation</p>
        <p>Ce vote n'a pas encore été envoyé sur la blockchain et peut encore être modifié.</p>
        <p><em>Génération de la clé du vote en cours ...</em></p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
          <v-btn color="warning" @click="openDKGManager">
            Gestion DKG
          </v-btn>
          <v-btn color="green" link :to="`/votes/${vote.id}/editor`">
            Modifier le vote
          </v-btn>
          <v-btn icon="mdi-delete" size=small color="red" @click="deleteVote" />
        </div>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-if="vote.status === 'prepared' && vote.vote_pubkey != null" class="m-2">
      <v-card-text>
        <p class="text-xl mb-1">En préparation</p>
        <p>Ce vote n'a pas encore été envoyé sur la blockchain et peut encore être modifié.</p>
        <p v-if="!vote.vote_pubkey"><em>Génération de la clé du vote en cours ...</em></p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
          <v-btn color="primary" @click="openVote" :disabled="!vote.vote_pubkey">
            Lancer le vote
          </v-btn>
          <v-btn color="green" link :to="`/votes/${vote.id}/editor`">
            Modifier le vote
          </v-btn>
          <v-btn icon="mdi-delete" size=small color="red" @click="deleteVote" />
        </div>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-else-if="vote.status === 'open'" class="m-2">
      <v-card-text>
        <p class="text-xl mb-1">Ouvert</p>
        <p>Ce vote est en cours. Vous pouvez voter !</p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
          <v-btn color="red" @click="cancelVote">Annuler</v-btn>
        </div>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-else-if="vote.status === 'closed'" class="m-2">
      <v-card-text>
        <p class="text-xl mb-1">Dépouillement en cours</p>
        <p>Les résultats sont en train d'être calculés, veuillez patienter...</p>
      </v-card-text>
      <v-card-actions>
        <v-btn color="warning" @click="openDKGManager">
          Gestion DKG
        </v-btn>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-else-if="vote.status === 'validated'">
      <v-card-text>
        <p class="text-xl mb-1">Complété</p>
        <p>Ce vote est terminé. Les résultats sont disponibles.</p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
          <v-btn color="red" @click="archiveVote">Archiver</v-btn>
        </div>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-else-if="vote.status === 'archived'">
      <v-card-text>
        <p class="text-xl mb-1">Complété</p>
        <p>Ce vote a été archivé.</p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
        </div>
      </v-card-actions>
    </v-card>

    <v-card variant="plain" v-else-if="vote.status === 'canceled'">
      <v-card-text>
        <p class="text-xl mb-1" color="red">Annulé</p>
        <p>Ce vote a été annulé.</p>
      </v-card-text>
      <v-card-actions>
        <div class="flex grow items-center justify-between flex-col sm:flex-row">
          <v-btn icon="mdi-content-copy" size=small color="primary" @click="() => emit('clone')" />
        </div>
      </v-card-actions>
    </v-card>

    <v-dialog v-model="dkgManagerModal.displayed" max-width="500px" v-if="dkgManagerModal.displayed != null">
      <v-card>
        <v-card-title>
          <span class="text-h5">Gestion du DKG</span>
        </v-card-title>
        <v-card-text class="flex">
          <div>
            <v-timeline side="end">
              <v-timeline-item
                :dot-color="vote.vote_pubkey == null ? 'success' : 'warning'"
                size="small"
                :icon="vote.vote_pubkey == null ? 'mdi-check' : 'mdi-clock-outline'"
                fill-dot
              >
                <v-card :disabled="vote.vote_pubkey == null">
                  <v-card-title class="bg-error">
                    Génération de la clé publique
                  </v-card-title>
                  <v-card-text>
                    <p class="my-2">
                      <b>Attention </b>: réinitialiser la première phase alors que le vote a déjà eu lieu
                      rendra le déchiffrement impossible ! Comptez normalement 20-30s pour cette phase.
                    </p>
                    <div class="flex">
                      <v-btn color="error" variant="outlined" size="small" block :disabled="!dkgManagerModal.iKnowWhatIDo" @click="resetDKG('public')">
                        Réinitialiser la première phase
                      </v-btn>
                    </div>
                  </v-card-text>
                </v-card>
              </v-timeline-item>

              <v-timeline-item
                :dot-color="vote.vote_pubkey != null ? 'white' : 'warning'"
                size="small"
                icon="mdi-clock-outline"
                fill-dot
              >
                <v-card :disabled="vote.vote_pubkey != null">
                  <v-card-title class="bg-primary">
                    Génération de la clé privée
                  </v-card-title>
                  <v-card-text>
                    <p class="my-2">
                      Comptez normalement 5-10s pour cette phase.
                    </p>
                    <div class="flex">
                      <v-btn color="error" variant="outlined" size="small" block :disabled="!dkgManagerModal.iKnowWhatIDo" @click="resetDKG('private')">
                        Réinitialiser la seconde phase
                      </v-btn>
                    </div>
                  </v-card-text>
                </v-card>
              </v-timeline-item>

            </v-timeline>
          </div>
          <!-- <div class="w-[100%] p-5">
            <h4 class="text-lg">Informations de debug</h4>
            <div v-if="dkgManagerModal.dkgStatus != null">
              {{ JSON.stringify(dkgManagerModal.dkgStatus, null, ' ') }}
            </div>
            <v-alert v-else class="my-10" title="Pas d'information" text="Peut-être que le DKG n'existe pas pour ce vote (serveur qui a restart)"/>
          </div> -->
        </v-card-text>

        <v-card-actions class="justify-between items-center">
          <div class="grow">
            <v-checkbox density="compact" label="Je sais ce que je fais (vraiment ?)" hide-details v-model="dkgManagerModal.iKnowWhatIDo"/>
          </div>
          <v-btn variant="text" @click="() => dkgManagerModal.displayed = false">
            Fermer
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
